# -*- coding:utf-8 -*-
import wx

# 创建应用
app = wx.App()

# 创建不可调整尺寸的框架
win = wx.Frame(None, title='小楼的计算器', size=(220, 170),
               style=wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))

# 添加面板
pan = wx.Panel(win)

# 添加控件
rst = wx.TextCtrl(pan, value='0', size=(200, 30))
num1 = wx.Button(pan, label='1', size=(40, 25))
num2 = wx.Button(pan, label='2', size=(40, 25))
num3 = wx.Button(pan, label='3', size=(40, 25))
num4 = wx.Button(pan, label='4', size=(40, 25))
num5 = wx.Button(pan, label='5', size=(40, 25))
num6 = wx.Button(pan, label='6', size=(40, 25))
num7 = wx.Button(pan, label='7', size=(40, 25))
num8 = wx.Button(pan, label='8', size=(40, 25))
num9 = wx.Button(pan, label='9', size=(40, 25))
num0 = wx.Button(pan, label='0', size=(40, 25))
btn_a = wx.Button(pan, label='+', size=(40, 25))
btn_s = wx.Button(pan, label='-', size=(40, 25))
btn_m = wx.Button(pan, label='×', size=(40, 25))
btn_d = wx.Button(pan, label='÷', size=(40, 25))
btn_b = wx.Button(pan, label='←', size=(40, 25))
btn_c = wx.Button(pan, label='C', size=(40, 25))
btn_e = wx.Button(pan, label='=', size=(40, 75))
btn_dot = wx.Button(pan, label='•', size=(40, 25))

# 创建尺寸器
vbox1 = wx.BoxSizer(wx.VERTICAL)
vbox1.Add(num1)
vbox1.Add(num4)
vbox1.Add(num7)
vbox1.Add(btn_c)

vbox2 = wx.BoxSizer(wx.VERTICAL)
vbox2.Add(num2)
vbox2.Add(num5)
vbox2.Add(num8)
vbox2.Add(num0)

vbox3 = wx.BoxSizer(wx.VERTICAL)
vbox3.Add(num3)
vbox3.Add(num6)
vbox3.Add(num9)
vbox3.Add(btn_dot)

vbox4 = wx.BoxSizer(wx.VERTICAL)
vbox4.Add(btn_a)
vbox4.Add(btn_s)
vbox4.Add(btn_m)
vbox4.Add(btn_d)

vbox5 = wx.BoxSizer(wx.VERTICAL)
vbox5.Add(btn_b)
vbox5.Add(btn_e)

hbox = wx.BoxSizer()
hbox.Add(vbox1)
hbox.Add(vbox2)
hbox.Add(vbox3)
hbox.Add(vbox4)
hbox.Add(vbox5)

vbox = wx.BoxSizer(wx.VERTICAL)
vbox.Add(rst, flag=wx.CENTER)
vbox.Add(hbox, flag=wx.CENTER)


# 尺寸器设置到面板
pan.SetSizer(vbox)

# 创建计算相关参数的列表[计算结果,第2个数字,生效的运算符,最后添加的运算符]（也可设置4个变量）
lst = ['0', '0', '', '']


# 点击小数点按钮
def click_dot(event):
    if lst[3]:  # 如果有最后添加的运算符（即上一操作为点击运算符）
        lst[2] = lst[3]  # 将最后添加的运算符保存到生效的运算符
        lst[3] = ''  # 清空最后添加的运算符
        rst.SetValue('0.')  # 设置显示的数字
    elif rst.GetValue() == '0':  # 如果显示的数字为'0'
        rst.SetValue('0.')  # 设置数字为'0.'
    elif '.' not in rst.GetValue():  # 如果显示的数字不包含'.'
        rst.SetValue(rst.GetValue() + '.')  # 添加小数点到当前显示数字的后方


# 点击清空按钮
def click_clr(event):
    global lst
    rst.SetValue('0')  # 设置显示的数字为'0'
    lst = ['0', '0', '', '']  # 初始化计算相关参数的列表


# 点击退格按钮
def click_back(event):
    if len(rst.GetValue()) > 1:  # 如果当前显示数字的长度超过1位
        rst.SetValue(rst.GetValue()[:-1])  # 设置当前显示数字为截取后的数字
    else:
        rst.SetValue('0')  # 设置显示数字为'0'


# 计算函数
def compute(event):
    if not lst[2] and lst[3]:  # 如果只有最后添加的运算符
        rst.SetValue(str(eval(lst[0] + lst[3] + lst[1])))  # 组织计算字符串进行计算
    if lst[2]:  # 如果有生效的运算符
        lst[1] = rst.GetValue()  # 设置第2个数字为当前显示的数字
        rst.SetValue(str(eval(lst[0] + lst[2] + lst[1])))  # 组织计算字符串进行计算
        lst[3] = lst[2]  # 将生效的运算符存到最后添加的运算符
        lst[2] = ''  # 清空生效的运算符
    lst[0] = rst.GetValue()  # 设置计算结果为当前显示的数字


# 点击数字按钮
def click_num(event, value):
    if lst[3]:  # 如果有最后添加的运算符
        lst[2] = lst[3]  # 将最后添加的运算符保存到生效的运算符
        lst[3] = ''  # 清空最后添加的运算符
        rst.SetValue(value)  # 设置显示的数字为当前被点击按钮的数字
    elif rst.GetValue() == '0':  # 如果当前显示的数字是'0'
        rst.SetValue(value)  # 设置显示的数字为当前被点击按钮的数字
    else:  # 否则
        rst.SetValue(rst.GetValue() + value)  # 在当前显示数字的后方叠加被点击按钮的数字


# 点击运算符按钮
def click_ope(event, value):
    if lst[2]:  # 如果有生效的运算符
        compute(event)  # 调用计算函数
    else:  # 否则
        lst[0] = lst[1] = rst.GetValue()  # 设置计算结果和第2个数值为当前显示的数字
    lst[3] = value  # 设置最后添加的运算符为最后一次点击的运算符


# 绑定控件与函数
btn_e.Bind(wx.EVT_BUTTON, compute)
btn_a.Bind(wx.EVT_BUTTON, lambda evt: click_ope(evt, '+'))  # 通过lambda表达式调用功能函数并传入参数（运算符）
btn_s.Bind(wx.EVT_BUTTON, lambda evt: click_ope(evt, '-'))
btn_m.Bind(wx.EVT_BUTTON, lambda evt: click_ope(evt, '*'))
btn_d.Bind(wx.EVT_BUTTON, lambda evt: click_ope(evt, '/'))
btn_c.Bind(wx.EVT_BUTTON, click_clr)
btn_b.Bind(wx.EVT_BUTTON, click_back)
btn_dot.Bind(wx.EVT_BUTTON, click_dot)
num1.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '1'))  # 通过lambda表达式调用功能函数并传入参数（数字）
num2.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '2'))
num3.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '3'))
num4.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '4'))
num5.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '5'))
num6.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '6'))
num7.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '7'))
num8.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '8'))
num9.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '9'))
num0.Bind(wx.EVT_BUTTON, lambda evt: click_num(evt, '0'))

# 显示窗口
win.Show()
# 循环运行主程序
app.MainLoop()
